
-- block
-- that has a question

freeslot("SPR_MBPU", "SPR_MBSC", "MT_SMB_MUSHROOM")--, "S_SMB_MUSHROOM", "S_SMB_QBLOCKTOP", "MT_SMB_QBLOCK")

mobjinfo[MT_SMB_MUSHROOM] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 8*FU,
	height = 16*FU,
	speed = 4*FU,
	flags = MF_SPECIAL
}

local function getWallAngle(mo, line) -- not a function in source (as far as i know), but the code in the function was taken from PTR_GlideClimbTraverse
	if not (line and line.valid)
	or not (mo and mo.valid) return end
	
	local climbangle, climbline
	local whichside = P_PointOnLineSide(mo.x, mo.y, line)
	
	climbline = R_PointToAngle2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)
	climbangle = climbline

	if (whichside) // on second side?
		climbline = $+ANGLE_180
	end

	climbangle = $+(ANGLE_90 * (whichside and -1 or 1))
	
	return climbangle, climbline
	-- note to self:
	-- climbangle = the angle facing the wall
	-- climbline = the angle the line's going
end

addHook("MobjSpawn", function(mo)
	mo.angle = $+FixedAngle(P_RandomRange(-45, 45)*FU)
end, MT_SMB_MUSHROOM)

addHook("MobjThinker", function(mo)
	mo.sprite = SPR_MBPU
	if mo.smb1upmush == 1
		mo.frame = B
	elseif mo.smb1upmush == 2
		mo.frame = K
	else
		mo.frame = A
	end
	P_InstaThrust(mo, mo.angle, mobjinfo[mo.type].speed)
	
	if netplay
	and displayplayer
		local p = displayplayer
		if skins[p.skin].name ~= "smbmario"
			mo.flags2 = $1|MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
		end
	end
end, MT_SMB_MUSHROOM)

addHook("MobjMoveBlocked", function(mo, _, line)
	if not (line and line.valid) then return end
	
	mo.angle = getWallAngle(mo, line)+ANGLE_180+FixedAngle(P_RandomRange(-45, 45)*FU)
end, MT_SMB_MUSHROOM)

sfxinfo[freeslot("sfx_smb1up")].caption = "1up"

addHook("TouchSpecial", function(mo, pmo)
	if netplay
	and pmo.skin ~= "smbmario" then return true end
	
	if mo.smb1upmush == 1
		P_GivePlayerLives(pmo.player, 1)
		S_StartSound(pmo, sfx_smb1up, pmo.player)
	elseif mo.smb1upmush == 2
		P_DamageMobj(pmo, mo)
	elseif pmo.player.smbpowerup < 1
		pmo.player.smbgetpowerup = true
	end
	if mo.smb1upmush ~= 2
		local score = mo.smb1upmush ~= 1 and 1000 or 0
		local frame = mo.smb1upmush == 1 and K or F
		P_AddPlayerScore(pmo.player, score)
		local score = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
		score.scale = mo.scale
		score.tics = $*2
		score.momz = 5*FU
		score.tics = TICRATE
		score.sprite = SPR_MBSC
		score.frame = frame
	end
end, MT_SMB_MUSHROOM)