
-- block
-- that has a question

freeslot("SPR_MBQB", "S_SMB_QBLOCKSIDE", "S_SMB_QBLOCKTOP", "S_SMB_QBLOCKUSED", "MT_SMB_QBLOCK")

states[S_SMB_QBLOCKSIDE] = {
    sprite = SPR_MBQB,
    frame = A|FF_ANIMATE,
    tics = -1,
    var1 = C,
	var2 = 6
}

states[S_SMB_QBLOCKTOP] = {
    sprite = SPR_MBQB,
    frame = E|FF_ANIMATE,
    tics = -1,
    var1 = C,
	var2 = 6
}

states[S_SMB_QBLOCKUSED] = {
    sprite = SPR_MBQB,
    frame = D,
    tics = -1
}

mobjinfo[MT_SMB_QBLOCK] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 8*FU,
	height = 16*FU,
	flags = MF_NOGRAVITY|MF_SOLID
}

freeslot("SPR_MBCO", "S_SMB_BLOCKCOIN", "MT_SMB_QBFALSE")

states[S_SMB_BLOCKCOIN] = {
    sprite = SPR_MBCO,
    frame = A|FF_ANIMATE,
    tics = TICRATE-TICRATE/6,
	var1 = D,
	var2 = 1
}

mobjinfo[MT_SMB_QBFALSE] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_INVISIBLE,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 8*FU,
	height = 16*FU,
	flags = MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT
}

addHook("MapLoad", function()
	if not netgame
		local smbcount = 0
		for p in players.iterate do
			if skins[p.skin].name == "smbmario"
			or skins[p.skin].name == "overlario" then
				smbcount = $+1
			end
		end
		
		if smbcount == 0 then return end
	end
	
	for mo in mobjs.iterate() do
		if not (mo.flags & MF_MONITOR)
		or (mo.flags & MF_BOXICON) then continue end
		
		local ismarioblock = false
		local tempi = 1
		while (mo.subsector.sector.lines[tempi] and mo.subsector.sector.lines[tempi].valid) do
			if mo.subsector.sector.lines[tempi].special == 250 then
				ismarioblock = true
				break
			end
			tempi = $+1
		end
		
		if ismarioblock then continue end
		
		local qb = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMB_QBLOCK)
		qb.smbogheight = mo.height
		qb.scale = mo.scale*2
		qb.flags2 = mo.flags2
		qb.eflags = mo.eflags
		qb.qbtype = mo.type
		if not netgame
			P_RemoveMobj(mo)
		else
			qb.qbmon = mo
			mo.hassmbqblock = true
		end
	end
end)

local function handleVisibility(p, mo)
	if skins[p.skin].name == "smbmario"
		mo.qbmon.flags2 = $1|MF2_DONTDRAW
		mo.flags2 = $ & ~MF2_DONTDRAW
	else
		mo.qbmon.flags2 = $ & ~MF2_DONTDRAW
		mo.flags2 = $1|MF2_DONTDRAW
	end
end

addHook("MobjThinker", function(mo)
	if not mo.qbtype then return end
	
	if mo.smboverlays == nil
		mo.smboverlays = {
			paper = {},
			splat = {},
			sprites = {
				paper = S_SMB_QBLOCKSIDE,
				splat = S_SMB_QBLOCKTOP
			}
		}
		mo.falsez = mo.z
		mo.qbz = mo.z
		
		for i = 1, 4 do
			local ang = mo.angle+ANGLE_90*i
			local x, y = cos(ang), sin(ang)
			local ov = P_SpawnMobj(mo.x+FixedMul(mo.radius, x), mo.y+FixedMul(mo.radius, y), mo.z, MT_THOK)
			ov.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
			ov.renderflags = $1|RF_PAPERSPRITE
			ov.angle = ang-ANGLE_90
			ov.flags2 = mo.flags2
			ov.eflags = mo.eflags
			ov.state = mo.smboverlays.sprites.paper
			ov.scale = mo.scale
			table.insert(mo.smboverlays.paper, ov)
		end
		for i = 1, 2 do
			local add = i == 1 and mo.height or 0
			local ov = P_SpawnMobj(mo.x, mo.y, mo.z+add, MT_THOK)
			ov.flags = $1|MF_NOCLIP|MF_NOCLIPHEIGHT
			ov.renderflags = $1|RF_ABSOLUTEOFFSETS|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD
			ov.angle = mo.angle
			ov.flags2 = mo.flags2
			ov.eflags = mo.eflags
			ov.state = mo.smboverlays.sprites.splat
			ov.scale = mo.scale
			
			ov.spritexoffset = 8*FU
			ov.spriteyoffset = 8*FU
			table.insert(mo.smboverlays.splat, ov)
		end
	else
		if mo.qbused
			mo.smboverlays.sprites.paper = S_SMB_QBLOCKUSED
			mo.smboverlays.sprites.splat = S_SMB_QBLOCKUSED
		end
		
		for _, ov in ipairs(mo.smboverlays.paper) do
			if not (ov and ov.valid) then continue end
			
			local x, y = cos(ov.angle+ANGLE_90), sin(ov.angle+ANGLE_90)
			local state = mo.smboverlays.sprites.paper
			if ov.state ~= state
				ov.state = state
			end
			if (mo.flags & MF_NOTHINK)
				ov.flags = $1|MF_NOTHINK
			else
				ov.flags = $ & ~MF_NOTHINK
			end
			ov.flags2 = mo.flags2
			ov.eflags = mo.eflags
			P_MoveOrigin(ov, mo.x+FixedMul(mo.radius, x), mo.y+FixedMul(mo.radius, y), mo.falsez)
		end
		for k, ov in ipairs(mo.smboverlays.splat) do
			if not (ov and ov.valid) then continue end
			
			local add = k == 1 and mo.height or 0
			local state = mo.smboverlays.sprites.splat
			if ov.state ~= state
				ov.state = state
			end
			if (mo.flags & MF_NOTHINK)
				ov.flags = $1|MF_NOTHINK
			else
				ov.flags = $ & ~MF_NOTHINK
			end
			ov.flags2 = mo.flags2
			ov.eflags = mo.eflags
			P_MoveOrigin(ov, mo.x, mo.y, mo.falsez+add)
		end
	end
	
	if mo.falsez ~= mo.qbz
		--if mo.qbz == mo.z then print("hi") end
		local diff = max(min(mo.qbz-mo.falsez, 1), -1)
		--local addthingie = FixedDiv(diff, FU+FU/2)
		local addthingie = 6*FU*diff
		mo.falsez = $+addthingie
		if mo.falsez+addthingie > mo.qbz and diff == 1
		or mo.falsez+addthingie < mo.qbz and diff == -1
			mo.falsez = mo.qbz
		end
		--print(diff)
	end
	
	if not mo.qbspawned
		local z = max(mo.z+128*FU*P_MobjFlip(mo), P_FloorzAtPos(mo.x, mo.y, mo.z, mo.smbogheight))
		if z > P_CeilingzAtPos(mo.x, mo.y, mo.z, mo.smbogheight)
			z = P_CeilingzAtPos(mo.x, mo.y, mo.z, mo.smbogheight)-mo.height
		end
		P_SetOrigin(mo, mo.x, mo.y, z)
		mo.falsez = mo.z
		mo.qbz = mo.falsez
		mo.qbspawned = true
		mo.flags = $1|MF_NOTHINK
		mo.smblagprevention = true
		return
	end
	
	if mo.qbbounce
	and mo.falsez == mo.qbz
		mo.qbz = mo.z
		if mo.qbcoins ~= nil
		and mo.qbcoins-1 > 0
			mo.qbcoins = $-1
		else
			mo.qbused = true
		end
		mo.qbbounce = false
	end
	
	if mo.qbused
	and CV_FindVar("respawnitem").value ~= 0
	and netgame
		mo.qbusedtime = $ ~= nil and $+1 or 1
		
		if mo.qbusedtime >= CV_FindVar("respawnitemtime").value*TICRATE
			mo.smboverlays.sprites.paper = S_SMB_QBLOCKSIDE
			mo.smboverlays.sprites.splat = S_SMB_QBLOCKTOP
			mo.qbused = 0
			mo.qbusedtime = 0
			
			searchBlockmap("objects", function(_, nmon)
				if not (nmon.flags & MF_MONITOR) then return end
				
				if nmon.x == mo.x
				and nmon.y == mo.y
					mo.qbmon = nmon
					nmon.hassmbqblock = true
					return true
				end
			end, mo)
		end
	end
	
	if mo.qbmon and mo.qbmon.valid
		local mon = mo.qbmon
		
		if displayplayer
			handleVisibility(displayplayer, mo)
		end
		if secondarydisplayplayer
			handleVisibility(secondarydisplayplayer, mo)
		end
		
		if mon.health <= 0
		and not mo.qbused
			mo.qbused = true
		elseif mon.health ~= 0
		and mo.qbused
			mon.health = 0
			mon.state = S_BOX_POP2
		end
	/*else
		--print("hi!")*/
	end
end, MT_SMB_QBLOCK)

local function collide(pmo, mo)
	if not (mo and mo.valid)
	or not (pmo and pmo.valid)
	or not (pmo.player and pmo.player.valid)
	or not (mo.flags & MF_MONITOR)
	or pmo.skin ~= "smbmario"
	or not mo.hassmbqblock then return end
	
	return false
end

addHook("MobjCollide", collide, MT_PLAYER)
addHook("MobjMoveCollide", collide, MT_PLAYER)

local function fbcol(fb, mo)
	if not (fb and fb.valid)
	or not (fb.flags & MF_MISSILE)
	or not (fb.target and fb.target.valid)
	or not (fb.target.player and fb.target.player.valid)
	or fb.target.skin ~= "smbmario"
	or not (mo.flags & MF_MONITOR)
	or not mo.hassmbqblock then return end
	
	return false
end

addHook("MobjCollide", fbcol)
addHook("MobjMoveCollide", fbcol)

sfxinfo[freeslot("sfx_smbcoi")].caption = "Got coin"
sfxinfo[freeslot("sfx_smbitm")].caption = "Item spawned"

local function collide2(mo, pmo)
	if not (mo and mo.valid)
	or not (pmo and pmo.valid)
	or mo.type ~= MT_SMB_QBLOCK then return end
	
	if (pmo.player and pmo.player.valid)
	and pmo.skin ~= "smbmario"
	and netgame
		return false
	end
	
	if (pmo.type == MT_SMB_MUSHROOM or pmo.type == MT_SMB_FIREFLOWER or pmo.type == MT_SMB_STAR)
	and (pmo.z >= mo.z+mo.height and not (pmo.eflags & MFE_VERTICALFLIP) or pmo.z+pmo.height <= mo.z and (pmo.eflags & MFE_VERTICALFLIP))
	and (pmo.z+pmo.height > mo.z and not (pmo.eflags & MFE_VERTICALFLIP) or pmo.z < mo.z+mo.height and (pmo.eflags & MFE_VERTICALFLIP))
	and mo.z > pmo.floorz
	and mo.z+mo.height < pmo.ceilingz
	and pmo.momz*P_MobjFlip(pmo) < 0
	-- will make power ups not have momentum even while way higher than the ? block BUT, they're not even supposed to spawn there anyways...
		if pmo.type == MT_SMB_STAR
			P_SetObjectMomZ(pmo, FixedDiv(39*(FU/4), FU+FU/2))
		else
			pmo.momz = 0
		end
	end
	
	if mo.z > pmo.z+pmo.height
	or pmo.z > mo.z+mo.height
	or not (pmo.player and pmo.player.valid) then return end
	
	if pmo.momz ~= 0
	and (pmo.z+pmo.height == mo.z and not (pmo.eflags & MFE_VERTICALFLIP)
	or pmo.z == mo.z+mo.height and (pmo.eflags & MFE_VERTICALFLIP))
		local montype = (type(mo.qbtype) == "userdata" and mo.qbtype and mo.qbtype.valid and mo.qbtype.health ~= 0) and mo.qbtype.type or mo.qbtype
		
		local itemlist = {
			[MT_1UP_BOX] = {MT_SMB_MUSHROOM, 1},
			[MT_INVULN_BOX] = {MT_SMB_STAR},
			[MT_INVULN_GOLDBOX] = {MT_SMB_STAR},
			[MT_EGGMAN_BOX] = {MT_SMB_MUSHROOM, 2},
			[MT_EGGMAN_GOLDBOX] = {MT_SMB_MUSHROOM, 2},
			[MT_RING_BOX] = {MT_COIN, 10}
		}
		
		if not mo.qbused
		and not mo.qbbounce
			--P_KillMobj(mo.qbtype, pmo, pmo)
			local type = (pmo.player.smbpowerup ~= nil and pmo.player.smbpowerup < 1 and MT_SMB_MUSHROOM or MT_SMB_FIREFLOWER)
			local is1up
			if itemlist[montype]
				type = itemlist[montype][1]
				is1up = itemlist[montype][2]
			end
			if type ~= MT_COIN
				local mush = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SMB_QBFALSE)
				mush.scale = mo.scale
				mush.flags2 = mo.flags2
				mush.eflags = mo.eflags
				mush.smbmaxheight = not (pmo.eflags & MFE_VERTICALFLIP) and mo.height or 0
				mush.smbpuptype = type
				mush.smb1upmush = is1up
				S_StartSound(mo, sfx_smbitm)
			else
				if mo.qbcoins == nil
					mo.qbcoins = is1up
				end
				local fakecoin = P_SpawnMobj(mo.x, mo.y, mo.z+mo.height, MT_THOK)
				fakecoin.flags = MF_NOCLIP|MF_NOCLIPHEIGHT
				fakecoin.momz = 14*FU
				fakecoin.state = S_SMB_BLOCKCOIN
				fakecoin.scale = mo.scale
				if displayplayer
				and skins[displayplayer.skin].name ~= "smbmario"
					fakecoin.flags2 = $|MF2_DONTDRAW
				end
				S_StartSound(fakecoin, sfx_smbcoi)
				P_GivePlayerRings(pmo.player, 1)
				P_AddPlayerScore(pmo.player, 200)
			end
			mo.qbbounce = true
			mo.falsez = $+mo.height/2*P_MobjFlip(pmo)
			mo.qbz = $+mo.height*P_MobjFlip(pmo)
		end
	end
end

addHook("MobjCollide", collide2, MT_SMB_QBLOCK)
addHook("MobjMoveCollide", collide2, MT_SMB_QBLOCK)

addHook("MobjThinker", function(mo)
	
	local flist = {
		[MT_SMB_MUSHROOM] = {A, B, K},
		[MT_SMB_FIREFLOWER] = {C, D, E, F},
		[MT_SMB_STAR] = {G, H, I, J}
	}
	mo.sprite = SPR_MBPU
	if mo.smbpuptype ~= MT_SMB_MUSHROOM
		mo.frame = flist[mo.smbpuptype][(leveltime/3)%4+1]
	else
		mo.frame = flist[mo.smbpuptype][(mo.smb1upmush ~= nil and mo.smb1upmush+1 or 1)]
	end
	
	local puptime = TICRATE/2
	if mo.smbpuptics
	and mo.smbpuptics >= puptime
		local mush = P_SpawnMobj(mo.x, mo.y, mo.z+(mo.smbmaxheight/puptime), mo.smbpuptype)
		mush.flags2 = mo.flags2
		mush.eflags = mo.eflags
		mush.scale = mo.scale
		mush.smb1upmush = mo.smb1upmush
		mush.momz = -P_MobjFlip(mo)
		P_RemoveMobj(mo)
		return
	else
		mo.z = $+mo.smbmaxheight/puptime
	end
	
	mo.smbpuptics = $ ~= nil and $+1 or 1
end, MT_SMB_QBFALSE)

addHook("MobjRemoved", function(mo)
	if mo.smboverlays
		for _, ov in ipairs(mo.smboverlays.paper) do
			if not (ov and ov.valid) then continue end
			
			P_RemoveMobj(ov)
		end
		for _, ov in ipairs(mo.smboverlays.splat) do
			if not (ov and ov.valid) then continue end
			
			P_RemoveMobj(ov)
		end
	end
end, MT_SMB_QBLOCK)

addHook("MobjFuse", function(mo)
	if not mo.smblagprevention
		mo.flags = $1|MF_NOTHINK
		mo.smblagprevention = true
	end
	return true
end, MT_SMB_QBLOCK)