
-- block
-- that has a question

freeslot("S_SMB_STAR", "MT_SMB_STAR")

states[S_SMB_STAR] = {
    sprite = SPR_MBPU,
    frame = G|FF_ANIMATE,
    tics = -1,
    var1 = 3,
	var2 = 3
}

mobjinfo[MT_SMB_STAR] = {
	doomednum = -1,
	spawnhealth = 1,
	spawnstate = S_SMB_STAR,
	deathstate = S_NULL,
	xdeathstate = S_NULL,
	deathsound = sfx_null,
	radius = 8*FU,
	height = 16*FU,
	speed = 8*FU,
	flags = MF_SPECIAL
}

local function getWallAngle(mo, line) -- not a function in source (as far as i know), but the code in the function was taken from PTR_GlideClimbTraverse
	if not (line and line.valid)
	or not (mo and mo.valid) return end
	
	local climbangle, climbline
	local whichside = P_PointOnLineSide(mo.x, mo.y, line)
	
	climbline = R_PointToAngle2(line.v1.x, line.v1.y, line.v2.x, line.v2.y)
	climbangle = climbline

	if (whichside) // on second side?
		climbline = $+ANGLE_180
	end

	climbangle = $+(ANGLE_90 * (whichside and -1 or 1))
	
	return climbangle, climbline
	-- note to self:
	-- climbangle = the angle facing the wall
	-- climbline = the angle the line's going
end

addHook("MobjThinker", function(mo)
	P_InstaThrust(mo, mo.angle, mo.info.speed)
	if P_IsObjectOnGround(mo)
		P_SetObjectMomZ(mo, FixedDiv(39*(FU/4), FU+FU/2))
	end
	if netplay
	and displayplayer
		local p = displayplayer
		if skins[p.skin].name ~= "smbmario"
			mo.flags2 = $1|MF2_DONTDRAW
		else
			mo.flags2 = $ & ~MF2_DONTDRAW
		end
	end
end, MT_SMB_STAR)

addHook("MobjMoveBlocked", function(mo, _, line)
	if not (line and line.valid) then return end
	
	mo.angle = getWallAngle(mo, line)+ANGLE_180+FixedAngle(P_RandomRange(-45, 45)*FU)
end, MT_SMB_STAR)

addHook("TouchSpecial", function(mo, pmo)
	if netplay
	and pmo.skin ~= "smbmario" then return true end
	
	pmo.player.powers[pw_invulnerability] = invulntics
	P_PlayJingle(pmo.player, JT_INV)
	P_AddPlayerScore(pmo.player, 1000)
	local score = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	score.scale = mo.scale
	score.momz = 5*FU
	score.tics = TICRATE
	score.sprite = SPR_MBSC
	score.frame = F
end, MT_SMB_STAR)