//angrysonics was here
freeslot("MT_MARIOFLAGPOLE", "S_MARIOFLAGPOLE", "SPR_MARG", "S_MARIO_FLAGPOLE")
states[S_MARIO_FLAGPOLE].sprite = SPR_PLAY
states[S_MARIO_FLAGPOLE].frame = SPR2_CLMB|FF_ANIMATE
states[S_MARIO_FLAGPOLE].var1 = 1
states[S_MARIO_FLAGPOLE].var2 = 1
states[S_MARIO_FLAGPOLE].tics = -1
states[S_MARIO_FLAGPOLE].nextstate = S_MARIO_FLAGPOLE

local BASESIZE = 48*FU

mobjinfo[MT_MARIOFLAGPOLE] = {
	spawnstate = S_MARIOFLAGPOLE,
	xdeathstate = S_MARIOFLAGPOLE,
	radius = 6*FU, 
	height = 152*FU,
	flags = MF_SPECIAL | MF_NOGRAVITY | MF_NOCLIPHEIGHT
}

// sprite, frame flags, tics, action, var1, var2, next state
states[S_MARIOFLAGPOLE] = {SPR_MARG, A, -1, nil, 0, 0, S_NULL}


local TIPPYTOP = 132*FU*3


-- 0 = 5000 score, 1 = 1up
local TOPOFPOLEBEHAVIOUR = 1

local function shouldActivateFlagpole()
	if netgame or multiplayer then return false end
	if skins[consoleplayer.skin].name ~= "smbmario" then return false end
	
	return true
end

local theFlagpole = nil

local SSF_REALEXIT = 1<<7 -- the ssf_exit is wrong lmao

addHook("MapThingSpawn", function (mo, thing)
	if not shouldActivateFlagpole() then return end
	local sectoron = mo.subsector.sector
	if not (sectoron.specialflags & SSF_REALEXIT) then
		local aNeighborIsExit = false
		for i=1,#sectoron.lines do
			local line = sectoron.lines[i]
			if line.frontsector == sectoron
				and line.backsector
				and (line.backsector.specialflags & SSF_REALEXIT)
			then
				aNeighborIsExit = true
				break
			end
			if line.backsector == sectoron
				and line.frontsector
				and (line.frontsector.specialflags & SSF_REALEXIT)
			then
				aNeighborIsExit = true
				break
			end
		end
		if not aNeighborIsExit then return end		
	end
	local pole = P_SpawnMobjFromMobj(mo, 0, 0, BASESIZE, MT_MARIOFLAGPOLE)
	theFlagpole = pole
	pole.scale = $ * 3
	/*
	local z = 0
	if P_MobjFlip(pole) == 1 then
		z = pole.floorz + BASESIZE
	else
		z = pole.ceilingz - pole.height - BASESIZE
	end
	P_SetOrigin(mo, mo.x, mo.y, z)
	*/
	mo.fuse = 1
	pole.angle = thing.angle * ANG1
end, MT_SIGN)

addHook("MobjSpawn", function (mo, thing)
	mo.flag = P_SpawnMobjFromMobj(mo, 0, 0, TIPPYTOP-12*FU, MT_THOK)
	mo.flag.sprite = SPR_MARG
	mo.flag.frame = B | FF_PAPERSPRITE
	mo.flag.tics = -1
	mo.flag.scale = $ * 3
	mo.flag.angle = mo.angle 
	
	mo.score = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	mo.score.sprite = SPR_MARG
	mo.score.flags2 = $ | MF2_DONTDRAW
	mo.score.frame = C --| FF_PAPERSPRITE
	mo.score.tics = -1
	mo.score.scale = $ * 3
	
	local basecollider = P_SpawnMobjFromMobj(
		mo,
		0,
		0,
		-BASESIZE,
		MT_THOK
	)
	basecollider.flags = MF_SOLID
	basecollider.radius = BASESIZE/2
	basecollider.height = BASESIZE
	basecollider.tics = -1
	basecollider.sprite = SPR_NULL
	
	for i=0,359,90 do
		local side = P_SpawnMobjFromMobj(
			mo,
			FixedMul(sin(i*ANG1), BASESIZE)/2,
			FixedMul(cos(i*ANG1), BASESIZE)/2,
			0,
			MT_THOK
		)
		side.sprite = SPR_MARG
		side.frame = K | FF_PAPERSPRITE
		side.tics = -1
		side.scale = $ * 3
		side.angle = i*ANG1
	end
	local top = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_THOK)
	top.sprite = SPR_MARG
	top.frame = J | FF_FLOORSPRITE
	top.tics = -1
	top.scale = $ * 3
	top.renderflags = $ | RF_NOSPLATBILLBOARD
end, MT_MARIOFLAGPOLE)

addHook("PlayerSpawn", function (p)
	p.marioFlagpoling = nil
end)


addHook("PostThinkFrame", function ()
	for p in players.iterate do
		if not p then continue end
		if not shouldActivateFlagpole() then return end
		if ((p.pflags & PF_FINISHED) or p.exiting) and not p.marioFlagpoling and (theFlagpole and theFlagpole.valid) then
			p.exiting = 0
			p.pflags = $ & ~(PF_FINISHED | PF_FULLSTASIS)
		end
		if p.marioFlagpoling
			local flagstate = p.marioFlagpoling
			if S_MusicName():upper() ~= "RETROS" then
				S_ChangeMusic(
					"RETROS", false, consoleplayer,
					0, flagstate.tics*200/7
				)
			end
			-- this also assumes the goal is upright
			p.mo.momx = 0
			p.mo.momy = 0
			p.mo.momz = 0
			if flagstate.tics < 37 then
				p.drawangle = flagstate.angle+ANGLE_180
				flagstate.height = max(0, $ - (54*FU/5))
				P_MoveOrigin(
					p.mo,
					flagstate.flag.x+cos(flagstate.angle)/4,
					flagstate.flag.y+sin(flagstate.angle)/4,
					flagstate.flag.z + flagstate.height
				)
			else
				p.drawangle = flagstate.angle
				P_SetOrigin(
					p.mo,
					flagstate.flag.x-cos(flagstate.angle)/4,
					flagstate.flag.y-sin(flagstate.angle)/4,
					flagstate.flag.z
				)
			end
			flagstate.flagheight = max(0, $ - (54*FU/5))
			P_MoveOrigin(
				flagstate.flag.flag,
				flagstate.flag.x,
				flagstate.flag.y,
				flagstate.flag.z + flagstate.flagheight
			)
			P_MoveOrigin(
				flagstate.flag.score,
				flagstate.flag.x,
				flagstate.flag.y,
				flagstate.flag.z + (TIPPYTOP - flagstate.flagheight)
			)
			flagstate.tics = $ + 1
			if flagstate.tics < 37 then
				p.mo.state = S_MARIO_FLAGPOLE
			else
				p.mo.state = S_MARIO_FLAGPOLE
				p.mo.frame = A
			end
			
			--DEBUG
			--flagstate.angle           = $ + ANG1
			--flagstate.flag.angle      = $ + ANG1
			--flagstate.flag.flag.angle = $ + ANG1
		end
	end
end)

addHook("TouchSpecial", function (special, toucher)
	if
		toucher.player
		and not toucher.player.marioFlagpoling
		and shouldActivateFlagpole()
		and #(toucher.player) == 0
	then
		toucher.player.marioFlagpoling = {
			flag = special,
			--this assumes you aren't upside down
			height = min(toucher.z - special.z, TIPPYTOP),
			flagheight = TIPPYTOP,
			angle = special.angle, --R_PointToAngle2(0, 0, toucher.momx, toucher.momy),
			tics = 0
		}
		toucher.player.exiting = 61
		
		local scoreGrade = 0
		/*
		0-17 pixels high: 100 points - 0
		18-57 pixels high: 400 points - 1
		58-81 pixels high: 800 points - 2
		82-127 pixels high: 2000 points - 3
		128-153 pixels high: 4000 points - 4
		Top of the flagpole: 5000 points - 5
		*/
		local y = (toucher.z - special.z) / (3*FU)
		if y >= 154 then
			scoreGrade = 5 + TOPOFPOLEBEHAVIOUR
		elseif y >= 128 then
			scoreGrade = 4
		elseif y >= 82 then
			scoreGrade = 3
		elseif y >= 58 then
			scoreGrade = 2
		elseif y >= 18 then
			scoreGrade = 1
		end
		
		if scoreGrade == 6
			P_GivePlayerLives(toucher.player, 1)
			S_StartSound(special.score, sfx_smb1up)
		else
			P_AddPlayerScore(toucher.player, ({100, 400, 800, 2000, 4000, 5000})[scoreGrade+1])
		end
		special.score.flags2 = $ & ~MF2_DONTDRAW
		special.score.frame = ($ & ~FF_FRAMEMASK) | (C + scoreGrade)
	end
	
	return true
end, MT_MARIOFLAGPOLE)


/* decided against the camera lock
addHook("PlayerCmd", function (p, cmd)
	if p.marioFlagpoling then
		local flip = -ANG1
		if p.marioFlagpoling.tics >= 37 then flip = -flip end
		cmd.angleturn = (p.marioFlagpoling.angle+(flip-ANGLE_90))/65536
	end
end)
*/

addHook("MusicChange", function(oldname, newname)
	if oldname:lower() == "retros" and newname:lower() == "_clear" then
		return "retrow"
	end
end)


--DEBUG
addHook("MobjSpawn", function(mo)
	P_KillMobj(mo)
end, MT_METALSONIC_BATTLE)