
-- hud
-- from Super Mario Brothers
-- released for the Nintendo Entertainment System

local ch = customhud

addHook("ThinkFrame", function()
	if not displayplayer then return end
	
	local p = displayplayer
	if not (p.realmo and p.realmo.valid) then return end
	
	local pmo = p.realmo
	if pmo.skin == "smbmario"
	and ch.enabled("rings")
		p.smbhudenabled = true
		ch.disable("rings")
		ch.disable("score")
		ch.disable("time")
		ch.disable("lives")
	elseif pmo.skin ~= "smbmario"
	and not ch.enabled("rings")
	and (p.smbhudenabled or p.smbhudenabled == nil)
		p.smbhudenabled = false
		ch.enable("rings")
		ch.enable("score")
		ch.enable("time")
		ch.enable("lives")
	end
end)

local worldlist = {}
addHook("MapLoad", function()
	local prevmap
	local curmap = 1--spstage_start
	local nextmap = mapheaderinfo[curmap].nextlevel
	/*while not (nextmap >= 1100 and nextmap <= 1103) do
		local mh = mapheaderinfo[curmap]
		
		if worldlist[curmap] then break end
		
		local worldnum = 1
		local lvlnum = 1
		if prevmap
			local pmh = mapheaderinfo[prevmap]
			if string.lower(pmh.lvlttl) == string.lower(mh.lvlttl)
				worldnum = worldlist[prevmap][1]
				lvlnum = worldlist[prevmap][2]+1
			else
				worldnum = worldlist[prevmap][1]+1
			end
		end
		if nextmap and (nextmap == curmap or (nextmap >= 1100 and nextmap <= 1103) or string.lower(mapheaderinfo[nextmap].lvlttl) ~= string.lower(mh.lvlttl) and lvlnum == 1)
			lvlnum = 0
		end
		
		worldlist[curmap] = {worldnum, lvlnum}
		prevmap = curmap
		curmap = nextmap
		nextmap = mapheaderinfo[curmap].nextlevel
		
		if nextmap == curmap then break end
	end
	
	--lastlvl at this point should be equals to prevmap
	for map = 1, 1035 do
		if worldlist[map]
		or not mapheaderinfo[map] then continue end
		
		worldlist[map] = {worldlist[prevmap][1]+1, 0}
		prevmap = map
	end*/
	
	for map = 1, 1035 do
		local mh = mapheaderinfo[map]
		
		if not mh then continue end
		
		local worldnum = 1
		local lvlnum = 1
		if prevmap
			local pmh = mapheaderinfo[prevmap]
			if string.lower(pmh.lvlttl) == string.lower(mh.lvlttl)
				worldnum = worldlist[prevmap][1]
				lvlnum = worldlist[prevmap][2]+1
			else
				worldnum = worldlist[prevmap][1]+1
			end
		end
		/*if nextmap and mapheaderinfo[nextmap] and (nextmap == map or not (nextmap >= 1100 and nextmap <= 1103) and string.lower(mapheaderinfo[nextmap].lvlttl) ~= string.lower(mh.lvlttl) and lvlnum == 1)
			lvlnum = 0
		end*/
		
		worldlist[map] = {worldnum, lvlnum}
		prevmap = map
		nextmap = mapheaderinfo[map].nextlevel
	end
end)

addHook("NetVars", function(net)
	worldlist = net($)
end)

ch.SetupFont("SMBLT")

ch.SetupItem("SMBHUD", "smbmario", function(v, p)
	if skins[p.skin].name ~= "smbmario" then return end
	
	local xmul = FixedDiv(320, 256)
	local fr = FixedRound -- i lov being quick
	local f = V_PERPLAYER|V_HUDTRANS
	-- MARIO text and also score
	local name = p.skincolor == SKINCOLOR_SMBGREEN and "LUIGI" or string.upper(skins[p.skin].hudname)
	ch.CustomFontString(v, fr(24*xmul), fr(16*xmul), name, "SMBLT", V_SNAPTOTOP|V_SNAPTOLEFT|f, "left", FU)
	ch.CustomNum(v, fr(24*xmul), fr(16*xmul)+8*FU, p.score, "SMBLT", 6, V_SNAPTOTOP|V_SNAPTOLEFT|f, "left", FU)
	
	-- Rings / Coins collected
	local cframe = (leveltime/8)%5+1
	if cframe > 1 then cframe = $-1 end
	if cframe == 4 then cframe = 2 end
	v.drawScaled(fr(88*xmul), fr(16*xmul)+8*FU, FU, v.cachePatch("SMBCOIN"+cframe), V_SNAPTOTOP|V_SNAPTOLEFT|f)
	ch.CustomFontString(v, fr(88*xmul)+8*FU, fr(16*xmul)+8*FU, "x", "SMBLT", V_SNAPTOTOP|V_SNAPTOLEFT|f, "left", FU)
	ch.CustomNum(v, fr(88*xmul)+16*FU, fr(16*xmul)+8*FU, p.rings, "SMBLT", 2, V_SNAPTOTOP|V_SNAPTOLEFT|f, "left", FU)
	
	-- WORLD part
	ch.CustomFontString(v, fr(144*xmul), fr(16*xmul), "WORLD", "SMBLT", V_SNAPTOTOP|V_SNAPTORIGHT|f, "left", FU)
	if worldlist[gamemap]
	and worldlist[gamemap][2] ~= 0
		-- world num
		ch.CustomNum(v, fr(144*xmul)+16*FU, fr(16*xmul)+8*FU, worldlist[gamemap][1], "SMBLT", 0, V_SNAPTOTOP|V_SNAPTORIGHT|f, "right", FU)
		
		-- never would u guess what this is
		ch.CustomFontString(v, fr(144*xmul)+16*FU, fr(16*xmul)+8*FU, "-", "SMBLT", V_SNAPTOTOP|V_SNAPTORIGHT|f, "left", FU)
		
		-- lvl num
		ch.CustomNum(v, fr(144*xmul)+24*FU, fr(16*xmul)+8*FU, worldlist[gamemap][2], "SMBLT", 0, V_SNAPTOTOP|V_SNAPTORIGHT|f, "left", FU)
	else
		ch.CustomNum(v, fr(144*xmul)+16*FU, fr(16*xmul)+8*FU, worldlist[gamemap][1], "SMBLT", 0, V_SNAPTOTOP|V_SNAPTORIGHT|f, "center", FU)
	end
	
	-- TIME part!!
	ch.CustomFontString(v, fr(201*xmul), fr(16*xmul), "TIME", "SMBLT", V_SNAPTOTOP|V_SNAPTORIGHT|f, "left", FU)
	local secs = p.realtime/TICRATE
	local countdown = CV_FindVar("smb_countdown") and CV_FindVar("smb_countdown").value or 0
	if countdown ~= 0
	or mapheaderinfo[gamemap].countdown then
		if mapheaderinfo[gamemap].countdown
			secs = max(0, mapheaderinfo[gamemap].countdown-p.realtime)/TICRATE
		else
			secs = max(0, 400*TICRATE-p.realtime)/TICRATE
		end
	end
	ch.CustomNum(v, fr(201*xmul)+8*FU, fr(16*xmul)+8*FU, secs, "SMBLT", 3, V_SNAPTOTOP|V_SNAPTORIGHT|f, "left", FU)
end)