
-- stuff i thought didnt need a seperate lua file
-- and that i also thought didnt fit in any other file

sfxinfo[freeslot("sfx_smbbmp")].caption = "Hit"

local function CMDPrint(p, str)
	if type(p) == "userdata"
	and (p and p.valid)
		CONS_Printf(p, str)
	else
		print(str)
	end
end

COM_AddCommand("smb_luigi", function(p, arg)
	local str = "smb_luigi <On/Off> - Changes your color to the Luigi one in Singleplayer if on."
	if not (p and p.valid)
	or not arg then
		CMDPrint(p, str)
		return
	end
	
	local color = {
		["on"] = SKINCOLOR_SMBGREEN,
		["off"] = SKINCOLOR_SMBRED,
		["0"] = SKINCOLOR_SMBGREEN,
		["1"] = SKINCOLOR_SMBRED,
		["true"] = SKINCOLOR_SMBGREEN,
		["false"] = SKINCOLOR_SMBRED
	}
	
	if not color[string.lower(arg)] then
		CMDPrint(p, str)
		return
	end
	
	if (p.mo and p.mo.valid)
	and p.mo.color == p.skincolor
		p.mo.color = color[string.lower(arg)]
	end
	p.skincolor = color[string.lower(arg)]
end)

COM_AddCommand("smb_input", function(p, run, crouch)
	if not (p and p.valid)
	or run == nil and crouch == nil then
		CMDPrint(p, "smb_input <run button> <crouch button> - Changes your run and crouch buttons, accepts C1, C2, C3 and Spin!")
		return
	end
	
	local buttonlist = {
		["custom1"] = BT_CUSTOM1,
		["c1"] = BT_CUSTOM1,
		["custom2"] = BT_CUSTOM2,
		["c2"] = BT_CUSTOM2,
		["custom3"] = BT_CUSTOM3,
		["c3"] = BT_CUSTOM3,
		["spin"] = BT_SPIN
	}
	
	local runbtn = buttonlist[string.lower(string.gsub(run, " ", ""))]
	local crouchbtn = buttonlist[string.lower(string.gsub(crouch, " ", ""))]
	if runbtn == crouchbtn
		CMDPrint(p, "Hey! Your run button and crouch button are the same! You'll probably want to change that!")
	end
	
	p.smbbtns.run = (runbtn ~= nil and runbtn or $)
	p.smbbtns.crouch = (crouchbtn ~= nil and crouchbtn or $)
	
	if not io then return end
	
	local file = io.openlocal("client/smbmario/buttons.dat", "w+")
	file:seek("set")
	for k, v in pairs(buttonlist) do
		if v == p.smbbtns.run
			file:write(k+"\n")
			break
		end
	end
	for k, v in pairs(buttonlist) do
		if v == p.smbbtns.crouch
			file:write(k+"\n")
			break
		end
	end
	file:flush()
	file:close()
end)

addHook("PreThinkFrame", function()
	local fskin = CV_FindVar("forceskin")
	if fskin.value ~= -1
	and skins[fskin.value]
	and skins[fskin.value].name == "smboverlay"
		CV_StealthSet(fskin, "smbmario")
		for p in players.iterate do
			R_SetPlayerSkin(p, "smbmario")
		end
		return
	end
	
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		
		if p.mo.skin == "smbmario" then
			p.smbissliding = (p.pflags & PF_SLIDING)
			p.smbfmove = p.cmd.forwardmove
		end
		
		if p.mo.skin ~= "smboverlay" then continue end
		
		S_StartSound(nil, sfx_notadd, p)
		CONS_Printf(p, "You're not supposed to use that!")
		R_SetPlayerSkin(p, "smbmario")
	end
end)

freeslot("S_SMB_COIN")

states[S_SMB_COIN] = {
    sprite = SPR_MBCO,
    frame = E|FF_ANIMATE|FF_GLOBALANIM,
    tics = -1,
    var1 = 4,
	var2 = 5
}

local coindist = 2048*FU
addHook("PostThinkFrame", function()
	for p in players.iterate do
		if not (p.mo and p.mo.valid) then continue end
		
		-- coin stuff
		searchBlockmap("objects", function(_, ring)
			if ring.type ~= MT_RING
			and ring.type ~= MT_COIN
			and ring.type ~= MT_SMB_QBLOCK then return end
			
			if ring.type == MT_SMB_QBLOCK
			and ring.smblagprevention
			and (p.mo.skin == "smbmario" -- if you're not smbmario then u shouldn't mess with these
				 or not netplay) -- unless you're not on an online game that is
				ring.flags = $ & ~MF_NOTHINK
				ring.smblagprevention = false
				ring.fuse = TICRATE
				return
			end
			
			if ring.type == MT_SMB_QBLOCK
			or not displayplayer then return end
			
			local prevstate = ring.info.deathstate
			if skins[displayplayer.skin].name == "smbmario"
				if ring.state == ring.info.spawnstate
					ring.flags2 = $ & ~MF2_DONTDRAW
					ring.state = S_SMB_COIN
					ring.spritexscale = $*2
					ring.spriteyscale = $*2
				elseif ring.state ~= S_SMB_COIN
					if S_SoundPlaying(p.mo, ring.info.deathsound)
						S_StopSoundByID(p.mo, ring.info.deathsound)
						S_StartSound(p.mo, sfx_smbcoi)
					end
					ring.flags2 = $|MF2_DONTDRAW
				end
			elseif ring.state == S_SMB_COIN
				ring.state = ring.info.spawnstate
				ring.spritexscale = $/2
				ring.spriteyscale = $/2
			end
		end, p.mo, p.mo.x-coindist, p.mo.x+coindist, p.mo.y-coindist, p.mo.y+coindist)
		
		if p.mo.skin ~= "smbmario" then continue end
		
		-- invincibility stuff
		if p.powers[pw_invulnerability]
		or p.smbgetpowerup and not p.smblosepowerup
		and p.smbpowerup >= 1
			if p.smbinvulncolor == SKINCOLOR_SMBFIRE
			and p.skincolor ~= SKINCOLOR_SMBFIRE
			and p.smbpowerup ~= 2
			or p.playerstate ~= PST_LIVE
				p.smbinvulncolor = nil
			elseif p.smbinvulncolor == SKINCOLOR_WHITE
			and p.skincolor ~= SKINCOLOR_WHITE
			and p.smbpowerup+1 == 2
				p.smbinvulncolor = nil
			end
			
			local colors = {(p.smbinvulncolor ~= nil and p.smbinvulncolor or p.skincolor), SKINCOLOR_SMBINVULN1, SKINCOLOR_SMBINVULN2, SKINCOLOR_SMBINVULN3}
			local ovcolors = {nil, SKINCOLOR_WHITE, SKINCOLOR_WHITE, SKINCOLOR_SMBINVULNSC}
			local curpal = (leveltime/3)%4+1
			if not (p.smbinvulnov and p.smbinvulnov.valid)
				p.smbinvulnov = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
				local ov = p.smbinvulnov
				ov.state = S_INVISIBLE
				ov.target = p.mo
			else
				local ov = p.smbinvulnov
				ov.skin = "smboverlay"
				ov.state = p.mo.state
				ov.tics = p.mo.tics
				ov.anim_duration = p.mo.anim_duration
				ov.sprite = p.mo.sprite
				ov.sprite2 = p.mo.sprite2
				ov.frame = p.mo.frame
				ov.flags2 = p.mo.flags2
				ov.eflags = p.mo.eflags
				ov.scale = p.mo.scale
				ov.spritexscale = p.mo.spritexscale
				ov.spriteyscale = p.mo.spriteyscale
				ov.spritexoffset = p.mo.spritexoffset
				ov.spriteyoffset = p.mo.spriteyoffset
				
				if ovcolors[curpal] ~= nil
					ov.color = SKINCOLOR_SMBINVULNSC
				else
					ov.flags2 = $1|MF2_DONTDRAW
				end
			end
			p.mo.color = colors[curpal]
			p.smbcolored = true
		elseif p.smbinvulnov
		and p.smbinvulnov.valid
			P_RemoveMobj(p.smbinvulnov)
		elseif p.smbcolored
			p.smbcolored = false
			p.mo.color = (p.smbinvulncolor ~= nil and p.smbinvulncolor or p.skincolor)
		else
			p.smbinvulncolor = p.mo.color
		end
	end
end)

addHook("MusicChange", function(oldn, newn, mflags)
	newn = string.upper($)
	if newn == "SECMBI"
	and string.upper(oldn) == "SECMBI"
		return "SMBINV"
	end
	
	if not consoleplayer
	or skins[consoleplayer.skin].name ~= "smbmario" then return end
	
	if newn == "_INV"
	or newn == "_MINV"
		local retval = "SMBINV"
		if P_RandomRange(1, 1000) == 1
			retval = "SECMBI"
		end
		return retval, mflags, true
	end
end)

local function initButtons(p)
	p.smbbtns = {}
	local buttons = {"Spin", "Custom1"}
	if io
		local file = io.openlocal("client/smbmario/buttons.dat", "r")
		
		if file
			file:seek("set")
			buttons[1] = file:read()
			buttons[2] = file:read()
			file:close()
		end
	end
	
	COM_BufInsertText(p, "smb_input "+buttons[1]+" "+buttons[2])
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smbmario" then
		if p.smbinvulnov
		and p.smbinvulnov.valid
			P_RemoveMobj(p.smbinvulnov)
		end
		return
	end
	
	if not p.smbbtns
		initButtons(p)
	end
	
	-- dead anim stuff
	p.powers[pw_underwater] = 0
	if p.playerstate == PST_DEAD
		p.smbdeadtime = $+1
		
		local time = TICRATE/2+TICRATE/5
		if p.smbdeadtime < time
			P_SetObjectMomZ(p.mo, FixedDiv(7*FU, 10*FU))
		elseif p.smbdeadtime == time
			P_SetObjectMomZ(p.mo, 15*FU)
		end
		
		if p.smbdeadtime < 2*TICRATE+TICRATE/2
			if p.deadtimer > TICRATE
				p.deadtimer = TICRATE
			end
		elseif p.smbdeadtime >= 2*TICRATE+TICRATE/2
		and p.lives > -1
		and p.lives < 1
		and S_MusicName(p) == "smbdie"
			p.deadtimer = 2*TICRATE
			P_PlayJingle(p, JT_GOVER)
		end
	else
		p.smbdeadtime = 0
	end
	
	-- bump sfx
	if (p.mo.z+p.mo.height+p.mo.momz > p.mo.ceilingz and not (p.mo.eflags & MFE_VERTICALFLIP)
	or p.mo.z+p.mo.momz < p.mo.floorz and (p.mo.eflags & MFE_VERTICALFLIP))
	and not (mapheaderinfo[gamemap].typeoflevel & TOL_MARIO)
		S_StartSound(p.mo, sfx_smbbmp)
	end
	
	-- invincibility stuff!!
	/*if (p.cmd.buttons & BT_CUSTOM3)
		p.powers[pw_invulnerability] = TICRATE
	end*/
	
	/*if p.powers[pw_invulnerability]
		if not (p.smbinvulnov and p.smbinvulnov.valid)
			p.smbinvulnov = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_OVERLAY)
			local ov = p.smbinvulnov
			ov.state = S_INVISIBLE
			ov.target = p.mo
		else
			local ov = p.smbinvulnov
			ov.skin = "smboverlay"
			ov.state = p.mo.state
			ov.tics = p.mo.tics
			ov.anim_duration = p.mo.anim_duration
			ov.sprite = p.mo.sprite
			ov.sprite2 = p.mo.sprite2
			ov.frame = p.mo.frame
			ov.flags2 = p.mo.flags2
			ov.eflags = p.mo.eflags
			ov.scale = p.mo.scale
			ov.spritexscale = p.mo.spritexscale
			ov.spriteyscale = p.mo.spriteyscale
			ov.spritexoffset = p.mo.spritexoffset
			ov.spriteyoffset = p.mo.spriteyoffset
			ov.color = SKINCOLOR_SMBINVULNSC
		end
	elseif p.smbinvulnov
	and p.smbinvulnov.valid
		P_RemoveMobj(p.smbinvulnov)
	end*/
end)

addHook("MusicChange", function(oldn, newn)
	if not consoleplayer
	or skins[consoleplayer.skin].name ~= "smbmario" then return end
	
	local p = consoleplayer
	if p.smbdeadtime and p.smbdeadtime < 2*TICRATE+TICRATE/2
	and string.lower(oldn) == "smbdie"
		return true
	end
end)

addHook("MobjDeath", function(pmo)
	if pmo.skin ~= "smbmario" then return end
	
	P_PlayJingleMusic(p, "SMBDIE", 0, false)
end, MT_PLAYER)

local function collide(pmo, mo)
	if mo.type ~= MT_EXTRALARGEBUBBLE
	or not (pmo and pmo.valid)
	or not (pmo.player and pmo.player.valid)
	or pmo.skin ~= "smbmario" then return end
	
	return false
end

addHook("MobjDeath", function(mo, inf, src)
	if not (mo.flags & MF_ENEMY) then return end
	
	local pmo = (src and src.valid) and (src.player and src.player.valid) and src or (inf and inf.valid) and (inf.player and inf.player.valid) and inf or nil
	if not (pmo and pmo.valid)
	or pmo.skin ~= "smbmario" then return end
	
	pmo.player.scoreadd = min($+1, 11)
	local scorelist = {100, 200, 400, 500, 800, 1000, 2000, 4000, 5000, 8000, -1}
	local score = scorelist[pmo.player.scoreadd]
	if score ~= -1
		P_AddPlayerScore(pmo.player, score)
	else
		P_GivePlayerLives(pmo.player, 1)
		S_StartSound(pmo, sfx_smb1up)
	end
	local fx = P_SpawnMobj(mo.x, mo.y, mo.z, MT_THOK)
	fx.scale = pmo.scale*2
	fx.momz = 5*FU
	fx.tics = TICRATE
	fx.sprite = SPR_MBSC
	fx.frame = pmo.player.scoreadd-1
	mo.state = mo.info.deathstate
	return true
end)