
-- tries making the physics
-- closer to smb1's physics
-- what else would it be like

sfxinfo[freeslot("sfx_smbswm")].caption = "Swim"

freeslot("S_SMB_SWIM", "S_SMB_SWIMIDLE", "S_SMB_SKID")

states[S_SMB_SWIMIDLE] = {
    sprite = SPR_PLAY,
    frame = SPR2_GLID|FF_ANIMATE,
    tics = -1,
    var1 = B,
	var2 = 4
}

states[S_SMB_SWIM] = {
    sprite = SPR_PLAY,
    frame = SPR2_SWIM|FF_SPR2ENDSTATE,
    tics = 2,
	var1 = S_SMB_SWIMIDLE,
	nextstate = S_SMB_SWIM
}

states[S_SMB_SKID] = {
    sprite = SPR_PLAY,
    frame = SPR2_SKID,
    tics = 3,
	nextstate = S_PLAY_WALK
}

local function unitMath(blocks, pixels, spixels, sspixels, ssspixels, spd)
	local basenum = 1
	blocks = $ ~= nil and tonumber($, 16)*(basenum*(16*FU)) or 0
	pixels = $ ~= nil and tonumber($, 16)*(basenum*FU) or 0
	spixels = $ ~= nil and tonumber($, 16)*(basenum*(FU/16)) or 0
	sspixels = $ ~= nil and tonumber($, 16)*(basenum*(FU/16/16)) or 0
	ssspixels = $ ~= nil and tonumber($, 16)*(basenum*(FU/16/16/16)) or 0
	spd = $ ~= nil and $ or true
	
	local retval = blocks+pixels+spixels+sspixels+ssspixels
	if spd then retval = FixedMul($, FixedDiv(60, TICRATE)) end
	
	return retval
end

local function convertUnit(blocks, pixels, spixels, sspixels, ssspixels, spd, div1, div2)
	div1 = tonumber($) ~= nil and tonumber($) or 24*FU
	div2 = tonumber($) ~= nil and tonumber($) or unitMath(0, 2, 9)
	local mul = FixedDiv(div1, div2)
	return FixedMul(unitMath(blocks, pixels, spixels, sspixels, ssspixels, spd), mul)
end

-- yes i did need all of these local variables
-- (im lying)
local mrunspd = convertUnit(0, 2, 9)
local mwalkspd = convertUnit(0, 1, 9)
local minwalkspd = convertUnit(0, 0, 1, 3)

local walkaccel = convertUnit(0, 0, 0, 9, 8)
local runaccel = convertUnit(0, 0, 0, "E", 4)

local rdeaccel = convertUnit(0, 0, 0, "D")
local sdeaccel = convertUnit(0, 0, 1, "A")
local skidspd = convertUnit(0, 0, 9)

local airaccel1 = convertUnit(0, 0, 0, 9, 8)
local airaccel2 = convertUnit(0, 0, 0, "E", 4)

local airdeaccelhigher = convertUnit(0, 0, 0, "E", 4)
local airdeaccellower1 = convertUnit(0, 0, 0, "D")
local airdeaccellower2 = convertUnit(0, 0, 0, 9, 8)

local jumpunit1 = FixedMul(39*(FU/4), FU+FU/4)
local jumpunit2 = unitMath(0, 5)
local jumpvellower = convertUnit(0, 4, 0, 0, 0, nil, jumpunit1, jumpunit2)
local jumpvelhigher = convertUnit(0, 5, 0, 0, 0, nil, jumpunit1, jumpunit2)
local swimvel = convertUnit(0, 1, 8, 0, 0, nil, jumpunit1, jumpunit2)

local unit1, unit2 = FU+FU/4, unitMath(0, 0, 7)

local holdagravlower = convertUnit(0, 0, 2, 0, 0, nil, unit1, unit2)
local holdagravlower2 = convertUnit(0, 0, 1, "E", 0, nil, unit1, unit2)
local holdagravhigher = convertUnit(0, 0, 2, 8, 0, nil, unit1, unit2)
--local holdaswim = convertUnit(0, 0, 0, "D", 0, nil, unit1, unit2)
local holdaswim = convertUnit(0, 0, 0, "F", 0, nil, unit1, unit2)

local fallgravlower = convertUnit(0, 0, 7, 0, 0, nil, unit1, unit2)
local fallgravlower2 = convertUnit(0, 0, 6, 0, 0, nil, unit1, unit2)
local fallgravhigher = convertUnit(0, 0, 9, 0, 0, nil, unit1, unit2)
--local fallswim = convertUnit(0, 0, 0, "A", 0, nil, unit1, unit2)
local fallswim = convertUnit(0, 0, 0, "C", 0, nil, unit1, unit2)


local function ApproachAngle(cur, apprch, factor) -- probably not approaching, but it's what directionchar uses in the source code so i copied it!!!
	if cur == nil
	or apprch == nil
	or factor == nil
		return cur
	end
	
	local diff = apprch-cur
	
	if diff
		if diff > ANGLE_180
			diff = InvAngle(InvAngle(diff)/factor)
		else
			diff = $/factor
		end
	end
	
	return cur+diff
end

local function isUnderwater(p)
	local bottom = (p.mo.eflags & MFE_VERTICALFLIP) and p.mo.height/2 or 0
	local top = not (p.mo.eflags & MFE_VERTICALFLIP) and p.mo.height/2 or 0
	return (p.mo.eflags & MFE_UNDERWATER) and p.mo.z+top <= p.mo.watertop and p.mo.z+bottom >= p.mo.waterbottom
end

local function getAirCDir(p, cang)
	--local momang = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
	if not (p.cmd.forwardmove and not (p.mo.flags2 & MF2_TWOD) or p.cmd.sidemove)
	or not (p.mo.momx or p.mo.momy) then return 0 end
	
	local diff = AngleFixed(cang) - AngleFixed(p.smbairangle)
	while diff > 180*FU do diff = $-360*FU end
	while diff < -180*FU do diff = $+360*FU end
	
	return (diff >= -90*FU and diff <= 90*FU) and 1 or 2
end

addHook("PlayerThink", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smbmario"
	or (p.pflags & PF_STASIS)
	or p.playerstate == PST_DEAD
	or P_PlayerInPain(p)
	or p.powers[pw_carry]
	or p.smbissliding
	or (p.pflags & PF_SPINNING) then return end
	
	p.mo.friction = FU
	p.jumpfactor = FU
	
	--p.mo.flags = $1|MF_NOGRAVITY
	local grounded = P_IsObjectOnGround(p.mo)
	local moving = (p.cmd.forwardmove and not (p.mo.flags2 & MF2_TWOD) or p.cmd.sidemove and true or false)
	
	if grounded
		p.smbairangle = p.drawangle
	elseif p.smbairangle ~= nil
	and not isUnderwater(p)
		p.drawangle = p.smbairangle
	end
	
	local movdir = P_GetPlayerControlDirection(p)
	
	local camang = p.cmd.angleturn<<16
	local cmdang = R_PointToAngle2(0, 0, p.cmd.forwardmove*FU, -p.cmd.sidemove*FU)
	local movang = camang+cmdang
	if (p.mo.flags2 & MF2_TWOD)
		movang = p.mo.angle
	end
	
	if not grounded then movdir = getAirCDir(p, movang) end
	local spd = FixedHypot(p.rmomx, p.rmomy)
	
	if (p.mo.eflags & MFE_SPRUNG)
		p.smbsprung = true
	elseif p.mo.momz*P_MobjFlip(p.mo) <= 0
	or grounded
		p.smbsprung = false
	end
	
	if (p.pflags & PF_STARTJUMP)
		local jumpvel = jumpvellower
		local jumpheight = 39*(FU/4)
		if isUnderwater(p)
			jumpvel = (p.mo.eflags & MFE_GOOWATER) and -swimvel or swimvel
			jumpheight = FixedMul($, FixedDiv(117*FRACUNIT, 200*FRACUNIT))
			S_StopSoundByID(p.mo, skins[p.skin].soundsid[SKSJUMP])
			p.mo.state = S_SMB_SWIM
		elseif spd > convertUnit(0, 2, 5)
			jumpvel = jumpvelhigher
		end
		P_SetObjectMomZ(p.mo, -jumpheight+jumpvel, true)
		p.pflags = $ & ~PF_STARTJUMP
	elseif isUnderwater(p)
	and p.mo.state ~= S_SMB_SWIM
	and p.mo.state ~= S_SMB_SWIMIDLE
	and not P_IsObjectOnGround(p.mo)
		p.mo.state = S_SMB_SWIM
	elseif not isUnderwater(p)
	and (p.mo.state == S_SMB_SWIM or p.mo.state == S_SMB_SWIMIDLE)
		p.mo.state = S_PLAY_JUMP
	end
	
	if p.smbmovang == nil
	or spd <= minwalkspd
	or (p.mo.flags2 & MF2_TWOD)
		p.smbmovang = movang
	elseif grounded
		p.smbmovang = ApproachAngle($, movang, 2)
	else
		p.smbmovang = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)
	end
	
	local mspd, accel = mwalkspd, walkaccel
	if p.smbbtns
	and p.smbbtns.run
	and (p.cmd.buttons & p.smbbtns.run)
		mspd, accel = mrunspd, runaccel
	end
	
	if movdir == 2
	and spd >= skidspd
	and grounded
		p.drawangle = R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy)+ANGLE_180
		p.skidtime = 2
		p.mo.state = S_SMB_SKID
	end
	
	local deaccel = rdeaccel
	if p.skidtime then deaccel = sdeaccel end
	p.acceleration = FU
	p.accelstart = minwalkspd
	p.normalspeed = mspd
	
	if grounded
		p.smbairspd = spd-- < convertUnit(0, 1, 9) and true or false
	else
		local unitthing = convertUnit(0, 1, 9)
		mspd = (p.smbairspd < unitthing+FU) and unitthing or convertUnit(0, 2, 9)
		accel = (p.smbairspd < unitthing) and airaccel1 or airaccel2
		if spd > unitthing
			deaccel = airdeaccelhigher
		else
			deaccel = (p.smbairspd >= convertUnit(0, 1, "D")) and airdeaccellower1 or airdeaccellower2
		end
		
		if not moving then deaccel = 0 end
		
		local lowergrav, lowergrav2, highergrav = fallgravlower, fallgravlower2, fallgravhigher
		if (p.cmd.buttons & BT_JUMP)
		and p.mo.momz*P_MobjFlip(p.mo) > 0
			lowergrav, lowergrav2, highergrav = holdagravlower, holdagravlower2, holdagravhigher
		end
		local grav = lowergrav
		if p.smbairspd >= convertUnit(0, 1)
		and p.smbairspd < convertUnit(0, 2, 5)
			grav = lowergrav2
		elseif p.smbairspd >= convertUnit(0, 2, 5)
			grav = highergrav
		end
		
		if isUnderwater(p)
			if (p.cmd.buttons & BT_JUMP)
			and p.mo.momz*P_MobjFlip(p.mo) > 0
				grav = holdaswim
			else
				grav = fallswim
			end
		end
		
		if not p.smbsprung
		and not (p.mo.eflags & MFE_GOOWATER)
			local gravmul = abs(FixedDiv(P_GetMobjGravity(p.mo), FU/2))-- FixedDiv(fallgravlower
			P_SetObjectMomZ(p.mo, abs(P_GetMobjGravity(p.mo))-FixedMul(grav, gravmul), true)
			
			if p.mo.momz*P_MobjFlip(p.mo) < FixedMul(-convertUnit(0, 4, 8, 0, 0, jumpunit1, jumpunit2), p.mo.scale)
				P_SetObjectMomZ(p.mo, -convertUnit(0, 4, 0, 0, 0, jumpunit1, jumpunit2))
			end
		end
	end
	
	mspd = FixedMul($, p.mo.scale)
	accel = FixedMul($, p.mo.scale)
	deaccel = FixedMul($, p.mo.scale)
	
	-- fix the pesky run anim speed yeay
	if (p.panim == PA_WALK
	or p.panim == PA_RUN)
	and spd > FixedMul(mwalkspd, p.mo.scale)+FU
		p.mo.tics = min($, 2)
		p.mo.anim_duration = min($, 2)
	end
	
	p.smbmovetimer = $ ~= nil and $ or 0
	if spd > mspd+FU
	and grounded
		if p.smbmovetimer >= FixedRound(10*FixedDiv(TICRATE, 60))/FU
		or movdir ~= 1
			P_InstaThrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), mspd)
			p.mo.momx = $+p.cmomx
			p.mo.momy = $+p.cmomy
		end
		p.smbmovetimer = $+1
	else
		p.smbmovetimer = 0
	end
	
	local thrustx, thrusty = P_ReturnThrustX(p.mo, movang, accel), P_ReturnThrustY(p.mo, movang, accel)
	if moving
	and spd+FixedHypot(thrustx, thrusty) < mspd
	and not p.skidtime
	and (movdir ~= 0 or grounded)
		if not grounded
		and movdir == 2
			accel = deaccel
		end
		
		P_Thrust(p.mo, movang, accel)
		
		if grounded
			P_InstaThrust(p.mo, p.smbmovang, FixedHypot(p.mo.momx, p.mo.momy))
		end
		
		P_MovePlayer(p)
	elseif spd <= mspd+2*FU
	and spd >= mspd
	and not p.skidtime
	and movdir ~= 0
	and grounded
		P_InstaThrust(p.mo, p.smbmovang, FixedHypot(p.mo.momx, p.mo.momy))
	else
		if spd > FU
			P_Thrust(p.mo, R_PointToAngle2(0, 0, p.mo.momx, p.mo.momy), -deaccel)
		elseif spd < FU/10
		and not (p.cmomx or p.cmomy)
			P_InstaThrust(p.mo, 0, 0)
		end
	end
end)

addHook("JumpSpecial", function(p)
	if not (p.mo and p.mo.valid)
	or p.mo.skin ~= "smbmario"
	or (p.pflags & PF_JUMPSTASIS)
	--or P_IsObjectOnGround(p.mo)
	or (p.pflags & PF_JUMPDOWN)
	or not (p.mo.eflags & MFE_UNDERWATER) then return end
	
	p.pflags = $ & ~PF_JUMPED
	P_DoJump(p, false)
	p.mo.state = S_PLAY_JUMP
	--S_StopSoundByID(p.mo, skins[p.skin].soundsid[SKSJUMP])
	if isUnderwater(p)
		S_StartSound(p.mo, sfx_smbswm)
	else
		S_StartSound(p.mo, sfx_jump)
	end
	/*p.mo.eflags = $ & ~MFE_JUSTHITFLOOR
	local jumpvel = jumpvellower
	if FixedHypot(p.rmomx, p.rmomy) > convertUnit(0, 2, 5)
		jumpvel = jumpvelhigher
	end
	P_SetObjectMomZ(p.mo, jumpvel)
	p.pflags = ($1|P_GetJumpFlags(p)) & ~PF_STARTJUMP
	p.mo.state = S_PLAY_JUMP
	S_StartSound(p.mo, sfx_jump)
	
	if (p.mo.eflags & MFE_UNDERWATER)
		p.mo.momz = FixedMul($, FixedDiv(117*FRACUNIT, 200*FRACUNIT))
	end*/
end)